//AB/ Project Md5sum Example View
//AB/ Object oIDE_Project is a View_Project
    //AB/ Set ProjectName to "Md5sum Example View"
    //AB/ Set ProjectFileName to "md5sumEx.VW"
    //AB/ Set Size to 370 541

// Project Object Structure
//   oMd5sumHashExVw is a dbView
//     oMd5sum_TD is a TabDialog
//       oTextEncoding_TP is a TabPage
//         oDecoded_tb is a cEdit
//         oEncodeText_bn is a Button
//         oDecode_bn is a Button
//         oEncoded_tb is a cEdit
//       oFileEncode_TP is a TabPage
//         oEncoded is a Form
//         oFile is a Form
//         oEncode_bn is a Button
//         oDecode_bn is a Button (Duplicate object name)
//         oOpenDialog1 is a OpenDialog
//         oSaveAsDialog1 is a SaveAsDialog

// Register all objects
Register_Object oMd5sum_TD
Register_Object oMd5sumHashExVw
Register_Object oDecode_bn
Register_Object oFile
Register_Object oDecoded_tb
Register_Object oEncode_bn
Register_Object oEncoded
Register_Object oEncoded_tb
Register_Object oEncodeText_bn
Register_Object oFileEncode_TP
Register_Object oOpenDialog1
Register_Object oSaveAsDialog1
Register_Object oTextEncoding_TP


//AB-StoreTopStart
Use cMd5sum.pkg 
Use parsefn.pkg

Object oMD5sum is a cMD5sum
End_Object

//AB-StoreTopEnd

//AB-IgnoreStart
Use dfClient.pkg
Use dfTabDg.pkg
Use Windows.pkg
Use cvEdit.pkg
Use File_dlg.Pkg
//AB-IgnoreEnd


Activate_View Activate_oMd5sumHashExVw For oMd5sumHashExVw

Object oMd5sumHashExVw Is a dbView
    Set Border_Style To Border_Thick
    Set Label To "Md5sum Encode example"
    Set Location To 6 6
    Set Size To 226 348

    //AB-DDOStart


    //AB-DDOEnd

    Object oMd5sum_TD Is a TabDialog
        Set Size To 191 333
        Set Location To 9 5
        Set peAnchors To anAll
        Object oTextEncoding_TP Is a TabPage
            Set Label To "Text Encoding"
            Object oDecoded_tb Is a cvEdit
                Set Size To 159 121
                Set Location To 8 8
                Set peAnchors To anBottomLeftRight
            End_Object    // oDecoded_tb

            Object oEncodeText_bn Is a Button
                Set Label To " Encode ->"
                Set Location To 8 135
                Set peAnchors To anBottomRight

                Procedure OnClick
                  String sData
                  String sHash 
                      
                  Get TextEditValue Of oDecoded_tb To sData
                  Get MD5String of oMD5sum sData to sHash
                  Set TextEditValue Of oEncoded_tb To sHash
                End_Procedure // OnClick
            End_Object    // oEncodeText_bn

            Object oEncoded_tb Is a cvEdit
                Set Size To 159 121
                Set Location To 8 192
                Set peAnchors To anBottomLeftRight
            End_Object    // oEncoded_tb

        End_Object    // oTextEncoding_TP

        Object oFileEncode_TP Is a TabPage
            Set Label To "File Encoding"
            Object oEncoded Is a Form
                Set Label To "MD5:"
                Set Size To 13 192
                Set Location To 29 40
                Set peAnchors To anLeftRight
                Set Label_Col_Offset To 2
                Set Label_Justification_Mode To jMode_Top
                Set Prompt_Button_Mode To pb_PromptOn
                Set Enabled_State To false
            End_Object    // oEncoded

            Object oFile Is a Form
                Set Label To "File:"
                Set Size To 13 192
                Set Location To 82 40
                Set peAnchors To anLeftRight
                Set Label_Col_Offset To 2
                Set Label_Justification_Mode To jMode_Top
                Set Prompt_Button_Mode To pb_PromptOn
                Set Form_Button_Bitmap Item 0 To "SelectImage.bmp"
                
                Procedure Prompt
                  Boolean bOk
                  String  sFileName
                  String  sInitialFolder
                  Handle  hoImageOpenDialog
                
                  Move (oOpenDialog1(Self)) To hoImageOpenDialog
                  Get ApplicationProgramPath To sInitialFolder
                  Set Initial_folder Of hoImageOpenDialog To sInitialFolder
                  Get Show_Dialog Of hoImageOpenDialog To bOk
                  If (bOk) Begin
                    // File_Title is Eq to the selected File_Name without the path
                    Get File_Name Of hoImageOpenDialog To sFileName
                    Set Value              Item 0 To sFileName
                    Set Item_Changed_State Item 0 To True
                  End
                End_Procedure // Prompt
            End_Object    // oFile

            Object oEncode_bn Is a Button
                Set Label To "Encode"
                Set Location To 102 105
                Set peAnchors To anLeft

                Procedure OnClick
                   String  sHash 
                   String  sEncoded
                   String  sDecoded
                   String  sFileSource // File and path
                   String  sFileName   //
                   String  sExtension 
                   String  sEncodedFile
                   String  sDecodedFile
                   Integer iSize iLoop
                   Integer iChIn       // Free In  Channel number
                   String  sProgramPath
                   Integer bStop
                   
                   Get Seq_New_Channel To iChIn
                   If (iChIn<>DF_SEQ_CHANNEL_NOT_AVAILABLE ) Begin
                   
                     Get ApplicationProgramPath To sProgramPath
                     
                     //Get Value Of oUrl Item 0 To sFileSource
                     Get Value Of oFile Item 0 To sFileSource
                     If (sFileSource<>"") Begin
                     End
                     Direct_Input Channel iChIn ("BINARY:"+sFileSource)
                       Get_Channel_Size iChIn To iSize
                       Set_Channel_Position iChIn To 0
                       
                     Close_Input channel iChIn
                      
                     Get md5file of oMd5sum sFileSource to sHash
                     Set Value of oEncoded to sHash
                  
                   End // Free In Channel And Free Out Channel
                   Else Begin
                     Send Info_Box "Not enough free channels available"
                   End

                
                End_Procedure // OnClick
                //AB-StoreEnd

            End_Object    // oDecode_bn

            Object oOpenDialog1 Is a OpenDialog
                //AB/ Set Location to 147 9
                Set Dialog_Caption To "Select a file"
                Set Filter_String To 'All images|*.bmp;*.gif;*.jpg;*.png;*.swf|Bitmaps|*.bmp|All Files|*.*'
            End_Object    // oOpenDialog1

            Object oSaveAsDialog1 Is a SaveAsDialog
            End_Object    // oSaveAsDialog1

        End_Object    // oFileEncode_TP

    End_Object    // oMd5sum_TD
    
    //AB-StoreStart 
    
    // Get the application programs path from the registry
    // 
    Function ApplicationProgramPath Returns String
      String  sProgramPath
      Handle  hoWorkspace
      String  sPaths 
      
      Get phoWorkspace  Of ghoApplication To hoWorkspace
      Get psProgramPath Of hoWorkspace    To sPaths
      Get PathAtIndex   of hoWorkspace sPaths 1 to sProgramPath
      If (Right(Trim(sProgramPath),1)<>"\") Move (sProgramPath+"\") to sProgramPath
      Function_Return sProgramPath
    End_Function // ApplicationProgramPath
    //AB-StoreEnd 

End_Object    // oMd5sumHashExVw


//AB-StoreStart

//AB-StoreEnd

//AB/ End_Object    // oIDE_Project
